Foreman - Bug #12523

Openstack doesn't work with fog 1.36
11/18/2015 11:02 AM - Daniel Lobato Garcia

Status: Closed
Priority: High
Assignee: Daniel Lobato Garcia
Category: Compute resources - OpenStack
Target version: 1.11.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/2942
Description

Our code (test_connection and more) relies on calling list_tenants on the Openstack Fog object -
https://github.com/fog/fog/blob/master/lib/fog/openstack/requests/compute/list_tenants.rb

This object needs an instance variable @identity_connection to make requests to Openstack Keystone. On fog versions prior to 1.36,
this variable was automatically set during authentication.

However, this commit
https://github.com/fog/fog/commit/4d5287020d961e794ac279c640c69a66238c33f7#diff-3aa267766daa7{21447cd3c77b43bf39R412
moves the instance variable setup to a “self.” (class) method.

Therefore the variable is simply never accessible so all parts on Fog 1.36 that call this instance variable from outside a Class (self. in
ruby) context are broken.

Related issues:
Related to Foreman - Refactor #12494: Update fog to 1.36.0 Closed 11/16/2015

Associated revisions

Revision 72eececc - 12/02/2015 07:06 AM - Daniel Lobato Garcia
Fixes #125283 - Openstack does not work with Fog 1.36

Problem:

In a recent refactor of Openstack in Fog, defining @identity_connection

was moved to a class method. This causes it to be unavailable in

instances of Fog::Compute::Openstack::Real which we use to retrieve

servers and so forth. More info on:
https://github.com/fog/fog/commit/4d5287020d961e794ac279c640c69a66238c33f7#commitcomment-14475988

Solution:

Monkeypatch until a new version of Fog is released. This patch just
modifies the authenticate method slightly so that the
@identity_connection variable is set up at the end of it.

History

#1 - 11/19/2015 02:47 AM - Dominic Cleal

- translation missing: en.field_release set to 71

#2 - 11/19/2015 02:48 AM - Dominic Cleal
- Related to Refactor #12494: Update fog to 1.36.0 added

#3 - 11/30/2015 01:25 AM - Marek Hulan
Fog tracking issue at https://github.com/fog/fog/issues/3770

#4 - 11/30/2015 03:08 AM - Dominic Cleal
also https://github.com/fog/fog/pull/3779
https://github.com/fog/fog/blob/master/lib/fog/openstack/requests/compute/list_tenants.rb
https://github.com/fog/fog/commit/4d5287020d961e794ac279c640c69a66238c33f7#diff-3aa267766daa7f21447cd3c77b43bf39R412
https://github.com/fog/fog/commit/4d5287020d961e794ac279c640c69a66238c33f7#commitcomment-14475988
https://github.com/fog/fog/issues/3770
https://github.com/fog/fog/pull/3779

#5 - 11/30/2015 04:15 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Daniel Lobato Garcia

- Pull request https://github.com/theforeman/foreman/pull/2942 added

#6 - 12/02/2015 08:02 AM - Daniel Lobato Garcia
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 72eececc3d59d4b39c968226e99424bb5ef9be71.
